-- <Cale> JordiGH: When you do, lev1 is the continuation of the C++ code at the top of the outer for loop, and lev2 is the continuation of a point just after the loop test

import qualified Data.Vector.Unboxed as V
import Data.Vector.Unboxed (Vector, (!))

levenshtein :: String -> String -> Int
levenshtein as bs = levenshteinV a b
  where a = V.fromList as
        b = V.fromList bs

levenshteinV a b = lev1 a b 1 row
  where row = V.generate (V.length b + 1) (\i -> i)

lev1 a b i row | i <= V.length a = lev2 a b i row
               | otherwise       = row ! V.length b

lev2 a b i row = lev1 a b (i+1) row'
  where row' = V.unfoldrN (V.length b + 1)
               (\(p,j) -> let p' = min (row ! (j-1) + 
                                        if a ! (i-1) == b ! (j-1) 
                                        then 0 
                                        else 1)
                                   (1 + min (row ! j) p)
                          in Just (p,(p',j+1)))
        (i,1)

main = print $ levenshtein lol omg
  where lol = show [1..1000]
        omg = show [2..1001]