import Control.Applicative
import Control.Monad
import Control.Monad.ST
import Control.Monad.State

import qualified Data.Vector.Unboxed.Mutable as V
import qualified Data.ByteString as BS
import qualified Data.ByteString.Unsafe as BS
import qualified Data.ByteString.Char8 as BSC

levenshtein :: BS.ByteString -> BS.ByteString -> Int
levenshtein a b = runST $ do
  prevrowInit <- V.new (BS.length b + 1)
  thisrowInit <- V.replicate (BS.length b + 1) 0
  
  forM_ [0..BS.length b] $ \i -> V.unsafeWrite prevrowInit i i
  (_, prevrow) <- flip execStateT (thisrowInit,prevrowInit) $ forM_ [1..BS.length a] $
   \i -> StateT $ \(thisrow, prevrow) -> do     
    V.unsafeWrite thisrow 0 i
    forM_ [1..BS.length b] $ \j -> V.unsafeWrite thisrow j =<< do
      let add
            | BS.unsafeIndex a (i-1) /= BS.unsafeIndex b (j-1) = 1
            | otherwise = 0
      min <$> fmap (+ add) (V.read prevrow (j-1))
          <*> fmap (+ 1) (min <$> V.unsafeRead prevrow j <*> V.unsafeRead thisrow (j-1))
    return ((), (prevrow, thisrow))
  V.unsafeRead prevrow (BS.length b)

lol :: BS.ByteString
lol = BSC.pack (show [1..1000])

omg :: BS.ByteString
omg = BSC.pack (show [2..1001])

main :: IO ()
main = print $ levenshtein lol omg